//+------------------------------------------------------------------+
//|              Scooby-doo Trend Retracement auto trading robot.mq4 |
//|                                                                  |
//|                                                                  |
//+------------------------------------------------------------------+

#property show_inputs
#include <WinUser32.mqh>
#include <stdlib.mqh>
#define  NL    "\n"
#define up "Up"
#define down "Down"
#define flat "Flat"
#define high "High"
#define low "Low"
#define none "None"

/*

void DisplayUserFeedback()
int start()
void GetPosition()
bool NewsExist()
void SendOrder(string symbol, int dir, double lots)
bool DoesTradeExist(string symbol)
void ManageTrades()
void Printtxt(string text, string str,int size, string font, color vcolor, double vertical, double horizontal) 

----Trend and market movement----
void Get_Trend(string symbol)
double GetTriggerPrice(int type, string symbol, double AtrVal)


----ATR----
double Get_ATR(string symbol, int tf, int multiplier)

----Swing hi-lo
void GetSwing(string symbol)


----Pairs traded----
void CleanUpInputString()
void CalculatePairsPassed()

*/


extern string  PairsToTrade = "AUDCAD,AUDCHF,AUDNZD,AUDJPY,AUDUSD,CADCHF,CADJPY,CHFJPY,EURAUD,EURCAD,EURCHF,EURGBP,EURNZD,EURJPY,EURUSD,GBPCHF,GBPJPY,GBPUSD,NZDUSD,NZDJPY,USDCAD,USDCHF,USDJPY,USDSGD";
extern double  Lots = 0.02;
extern int     MagicNumber = 563656;
extern string  TradeComment="ScRT";
extern bool    CriminalIsECN=false;
extern int     MaxTradesAllowed=6;
extern int     PendingTradesPipsDistance=150;
extern int     PendingTradesExpireMinutes=60;
extern int     AtrPeriod=14;
extern int     BEP=100;
extern bool    TradingSuspended=true;
extern string  srs="----Swing Retrace settings----";
extern bool    UseSwingRetrace=true;
extern int     SwingTimeFrame=240;
extern string  atrs="----ATR Retrace settings. Select one----";
extern bool    UseAtrRetrace=false;
extern bool    UseM15ATRrt=false;
extern bool    UseH1ATRrt=true;
extern bool    UseH4ATRrt=false;
extern bool    UseD1ATRrt=false;
extern double  RetraceAtrMultiplier=1;
extern string  tps="----Take profit settings. Select one----";
extern bool    UseM15ATRtp=false;
extern bool    UseH1ATRtp=false;
extern bool    UseH4ATRtp=false;
extern bool    UseD1ATRtp=true;
extern double  TpAtrMultiplier=1;
extern string  sls="----Stop loss settings. Select one----";
extern bool    UseM15ATRsl=false;
extern bool    UseH1ATRsl=false;
extern bool    UseH4ATRsl=false;
extern bool    UseD1ATRsl=true;
extern double  SlAtrMultiplier=1;
extern string  wei="----Week ending inputs----";
extern bool    FridayClose=true;
extern bool    SaturdayClose=false;
extern int     StopTradinhHour = 12;
extern string  dins="----Pair display settings----";
extern color   PairColour=Yellow;
extern color   LongColour=Green;
extern color   ShortColour=Red;
extern color   FlatColour=Blue;
extern bool    ShowPairsInformation=true;
extern double  DisplayHorizontalStart=80;
extern double  DisplayVerticalStart=12.2;
extern string  oae="----Odds and ends----";
extern int     DisplayGapSize=30;
                                    


//MA timeframes
int   M05 = PERIOD_M5;
int   M15 = PERIOD_M15;
int   M30 = PERIOD_M30;
int   H01 = PERIOD_H1;
int   H04 = PERIOD_H4;
int   D01 = PERIOD_D1;

//Trading
int   TicketNo;
int   NoOfTrades;

//Trading hours
bool  ClosedForFriday;
bool  ClosedForSaturday;

//Stop and tp ATR periods
int   RetraceAtrTf;
int   TpAtrTf;
int   SlAtrTf;
double EMA_020_M15;

//Swing
double   SwingHigh, SwingLow;//Holds value of hi-lo
string   Swing;

//Pair extraction
string    InputString;//Holds the contents PairsToTrade for tidying yp etc
int       NoOfPairs;// Holds the number of pairs passed by the user via the inputs screen
string    TradePair[]; //Array to hold the pairs traded by the user

//Misc stuff
int Decimals;
string Trend, ScreenMessage, Gap;
bool   RobotDisabled;
string DisabledMessage;


void DisplayUserFeedback()
{

   ScreenMessage = "";
   int cc;
   if (TradingSuspended) ScreenMessage = StringConcatenate(NL, ScreenMessage, Gap, "TRADING SUSPENDED TRADING SUSPENDED TRADING SUSPENDED TRADING SUSPENDED TRADING SUSPENDED TRADING SUSPENDED ", NL, NL);
   ScreenMessage = StringConcatenate(ScreenMessage, Gap, "Trading ", PairsToTrade, NL);
   ScreenMessage = StringConcatenate(ScreenMessage, Gap, "Lot size = ", Lots, NL);
   ScreenMessage = StringConcatenate(ScreenMessage, Gap, "Magic number: ", MagicNumber, NL);
   ScreenMessage = StringConcatenate(ScreenMessage, Gap, "Trade comment: ", TradeComment, NL);
   if (CriminalIsECN) ScreenMessage = StringConcatenate(ScreenMessage, Gap, "CriminalIsECN is true ", NL);
   else ScreenMessage = StringConcatenate(ScreenMessage, Gap, "CriminalIsECN is false ", NL);
   //ScreenMessage = StringConcatenate(ScreenMessage, Gap, "TradeHourStart = ", TradeHourStart, NL);
   //ScreenMessage = StringConcatenate(ScreenMessage, Gap, "TradeHourStop = ", TradeHourStop, NL);
   if (FridayClose) ScreenMessage= StringConcatenate(ScreenMessage, Gap, "Friday close = ", DoubleToStr(StopTradinhHour, 2), NL);
   if (SaturdayClose) ScreenMessage= StringConcatenate(ScreenMessage, Gap, "Saturday close = ", DoubleToStr(StopTradinhHour, 2), NL);
   if (ClosedForSaturday) ScreenMessage = StringConcatenate(ScreenMessage, Gap, "Trading suspended for Saturday close. Continuing to monitor open trades.", NL);
   if (ClosedForFriday) ScreenMessage = StringConcatenate(ScreenMessage, Gap, "Trading suspended for Friday close. Continuing to monitor open trades.", NL);
   if (UseAtrRetrace) ScreenMessage = StringConcatenate(ScreenMessage, Gap, "Using fixed retrace", NL);
   if (UseSwingRetrace) ScreenMessage = StringConcatenate(ScreenMessage, Gap, "Using swing retrace.", NL);
   ScreenMessage = StringConcatenate(ScreenMessage, Gap, "Take profit ATR period = ", TpAtrTf, NL);
   ScreenMessage = StringConcatenate(ScreenMessage, Gap, "Stop loss ATR period = ", SlAtrTf, NL);
   ScreenMessage = StringConcatenate(ScreenMessage, Gap, "Pending pips distance = ", PendingTradesPipsDistance, NL);
   ScreenMessage = StringConcatenate(ScreenMessage, Gap, "Pending trades expiry = ", PendingTradesExpireMinutes, " minutes", NL);
   ScreenMessage = StringConcatenate(ScreenMessage, Gap, "Break even profit = ", BEP, " pips", NL);
   ScreenMessage = StringConcatenate(ScreenMessage, NL);
   
   Comment(ScreenMessage);
      
   
   //Display pairs information
   if (ShowPairsInformation)
   {
      int v_size=7;
      double vertical = DisplayVerticalStart;
      vertical+= 0.8;
      double horizontal;
      string Label_Name;
      
      //Headings
      horizontal = DisplayHorizontalStart + 100;
      vertical+= 0.8;         
      Label_Name = "headlabel"+"a";
      Printtxt("M15",Label_Name,v_size,"Arial", PairColour,vertical,horizontal);
      horizontal+= 60;
            
      Label_Name = "headlabel"+"b";
      Printtxt("M60",Label_Name,v_size,"Arial", PairColour,vertical,horizontal);
      horizontal+= 60;
            
      Label_Name = "headlabel"+"c";
      Printtxt("H4",Label_Name,v_size,"Arial", PairColour,vertical,horizontal);
      horizontal+= 60;
            
      Label_Name = "headlabel"+"d";
      Printtxt("D1",Label_Name,v_size,"Arial", PairColour,vertical,horizontal);
      horizontal+= 60;
            
      Label_Name = "headlabel"+"dd";
      Printtxt("EMA",Label_Name,v_size,"Arial", PairColour,vertical,horizontal);
      horizontal+= 60;
            
      Label_Name = "headlabel"+"e";
      Printtxt("Market",Label_Name,v_size,"Arial", PairColour,vertical,horizontal);
      horizontal+= 60;
            
      Label_Name = "headlabel"+"f";
      Printtxt("Trigger",Label_Name,v_size,"Arial", PairColour,vertical,horizontal);
      horizontal+= 60;
            
      Label_Name = "headlabel"+"g";
      Printtxt("Price",Label_Name,v_size,"Arial", PairColour,vertical,horizontal);
      horizontal+= 60;
            
      Label_Name = "headlabel"+"h";
      Printtxt("TP",Label_Name,v_size,"Arial", PairColour,vertical,horizontal);
      horizontal+= 60;
            
      Label_Name = "headlabel"+"i";
      Printtxt("SL",Label_Name,v_size,"Arial", PairColour,vertical,horizontal);
      horizontal+= 60;
      
      Label_Name = "headlabel"+"j";
      Printtxt("Spread",Label_Name,v_size,"Arial", PairColour,vertical,horizontal);
      horizontal+= 60;
            
      for (cc = 0; cc < NoOfPairs; cc++)
      {
         string symbol = TradePair[cc];
         Get_Trend(symbol);
         
         horizontal = DisplayHorizontalStart;
         color v_color=Yellow;
         vertical+= 0.8;
         Label_Name = "mylabel"+DoubleToStr(cc,0);
         Printtxt(symbol,Label_Name,v_size,"Arial", PairColour,vertical,horizontal);
         horizontal+= 60;

         string thisone;
         thisone = flat; 
         v_color = FlatColour;
         if (Trend == up) 
         {
            thisone = up; 
            v_color = LongColour;
         }//if (Trend == up) 
         
         if (Trend == down) 
         {
            thisone = down; 
            v_color = ShortColour;
         }//if (Trend == up) 
         
         Label_Name = "mylabel"+DoubleToStr(cc,0) +"X";
         Printtxt(thisone, Label_Name, v_size,"Arial", v_color,vertical,horizontal);
         horizontal+= 40;

         int digits = MarketInfo(symbol, MODE_DIGITS);
         double AtrVal = Get_ATR(symbol, PERIOD_M15, 1);
         Label_Name = "mylabel"+DoubleToStr(cc,0) +"a";
         Printtxt(DoubleToStr(AtrVal, digits), Label_Name, v_size,"Arial", v_color,vertical,horizontal);
         horizontal+= 60;
         
         AtrVal = Get_ATR(symbol, PERIOD_H1, 1);
         Label_Name = "mylabel"+DoubleToStr(cc,0) +"b";
         Printtxt(DoubleToStr(AtrVal, digits), Label_Name, v_size,"Arial", v_color,vertical,horizontal);
         horizontal+= 60;
         
         AtrVal = Get_ATR(symbol, PERIOD_H4, 1);
         Label_Name = "mylabel"+DoubleToStr(cc,0) +"c";
         Printtxt(DoubleToStr(AtrVal, digits), Label_Name, v_size,"Arial", v_color,vertical,horizontal);
         horizontal+= 60;
         
         AtrVal = Get_ATR(symbol, PERIOD_D1, 1);
         Label_Name = "mylabel"+DoubleToStr(cc,0) +"d";
         Printtxt(DoubleToStr(AtrVal, digits), Label_Name, v_size,"Arial", v_color,vertical,horizontal);
         horizontal+= 60;
         
         double point = MarketInfo(symbol, MODE_POINT);
         
                     

         if (Trend == up) 
         {
            double ask = MarketInfo(symbol, MODE_ASK);
            v_color = LongColour;
            Label_Name = "ema"+DoubleToStr(cc,0) +"x";
            Printtxt(DoubleToStr(EMA_020_M15, digits), Label_Name, v_size,"Arial", v_color,vertical,horizontal);
            horizontal+= 60;
            Label_Name = "askprice"+DoubleToStr(cc,0) +"x";
            Printtxt(DoubleToStr(ask, digits), Label_Name, v_size,"Arial", v_color,vertical,horizontal);
            horizontal+= 60;
            AtrVal = Get_ATR(symbol, RetraceAtrTf, RetraceAtrMultiplier);
            double TriggerPrice = GetTriggerPrice(OP_BUY, symbol, AtrVal);
            Label_Name = "longtrigger"+DoubleToStr(cc,0) +"x";
            Printtxt(DoubleToStr(TriggerPrice, digits), Label_Name, v_size,"Arial", v_color,vertical,horizontal);
            horizontal+= 60;
            Label_Name = "longtradeprice"+DoubleToStr(cc,0) +"x";
            Printtxt(DoubleToStr(TriggerPrice + (PendingTradesPipsDistance * point), digits), Label_Name, v_size,"Arial", v_color,vertical,horizontal);
            horizontal+= 60;
            AtrVal = Get_ATR(symbol, TpAtrTf, TpAtrMultiplier);
            double tp = NormalizeDouble(TriggerPrice + (PendingTradesPipsDistance * point) + AtrVal,digits);
            Label_Name = "longtakeprofit"+DoubleToStr(cc,0) +"x";
            Printtxt(DoubleToStr(tp, digits), Label_Name, v_size,"Arial", v_color,vertical,horizontal);
            horizontal+= 60;
            AtrVal = Get_ATR(symbol, SlAtrTf, SlAtrMultiplier);
            double sl = NormalizeDouble(TriggerPrice + (PendingTradesPipsDistance * point) - AtrVal,digits);
            Label_Name = "longstoploss"+DoubleToStr(cc,0) +"x";
            Printtxt(DoubleToStr(sl, digits), Label_Name, v_size,"Arial", v_color,vertical,horizontal);
            horizontal+= 60;
            
         }//if (Trend == up) 
         
         if (Trend == down) 
         {
            double bid = MarketInfo(symbol, MODE_BID);
            v_color = ShortColour;
            Label_Name = "ema"+DoubleToStr(cc,0) +"x";
            Printtxt(DoubleToStr(EMA_020_M15, digits), Label_Name, v_size,"Arial", v_color,vertical,horizontal);
            horizontal+= 60;
            Label_Name = "bidprice"+DoubleToStr(cc,0) +"x";
            Printtxt(DoubleToStr(bid, digits), Label_Name, v_size,"Arial", v_color,vertical,horizontal);
            horizontal+= 60;
            AtrVal = Get_ATR(symbol, RetraceAtrTf, RetraceAtrMultiplier);
            TriggerPrice = GetTriggerPrice(OP_SELL, symbol, AtrVal);
            Label_Name = "shorttrigger"+DoubleToStr(cc,0) +"x";
            Printtxt(DoubleToStr(TriggerPrice, digits), Label_Name, v_size,"Arial", v_color,vertical,horizontal);
            horizontal+= 60;
            Label_Name = "shorttradeprice"+DoubleToStr(cc,0) +"x";
            Printtxt(DoubleToStr(TriggerPrice - (PendingTradesPipsDistance * point), digits), Label_Name, v_size,"Arial", v_color,vertical,horizontal);
            horizontal+= 60;
            AtrVal = Get_ATR(symbol, TpAtrTf, TpAtrMultiplier);
            tp = NormalizeDouble(TriggerPrice - (PendingTradesPipsDistance * point) - AtrVal,digits);
            Label_Name = "shorttakeprofit"+DoubleToStr(cc,0) +"x";
            Printtxt(DoubleToStr(tp, digits), Label_Name, v_size,"Arial", v_color,vertical,horizontal);
            horizontal+= 60;
            AtrVal = Get_ATR(symbol, SlAtrTf, SlAtrMultiplier);
            sl = NormalizeDouble(TriggerPrice - (PendingTradesPipsDistance * point) + AtrVal,digits);
            Label_Name = "shortstoploss"+DoubleToStr(cc,0) +"x";
            Printtxt(DoubleToStr(sl, digits), Label_Name, v_size,"Arial", v_color,vertical,horizontal);
            horizontal+= 60;
            
         }//if (Trend == up) 
         
         if (Trend == flat) horizontal+= 360;
         Label_Name = "spreadlabel"+DoubleToStr(cc,0) +"x";
         Printtxt(DoubleToStr(MarketInfo(symbol, MODE_SPREAD), 0), Label_Name, v_size,"Arial", v_color,vertical,horizontal);
         horizontal+= 60;
         
      }//for (cc = 0; cc < NoOfCurrencies; cc==)
   }//if (ShowPairsInformation)
   
   
}//End void DisplayUserFeedback()


//+------------------------------------------------------------------+
//| expert Initialization function                                   |
//+------------------------------------------------------------------+

int init()
  {

   if (!IsDemo() )
   {
      if (MagicNumber == 563656)
      {
         MessageBox("You cannot run this robot until changed the MagicNumber input from the default of 563656." + NL 
                    + "Please reload the robot with a new MagicNumber input.");
         Comment("                This robot can do nothing. Please reload it");
         DisabledMessage = "You need to change the MagicNumber input";
         RobotDisabled = true;
         return;
      }//if (MagicNumber == 4872635)
      
      //Insufficient length
      string mn = DoubleToStr(MagicNumber,0);
      if (StringLen(mn) < 5)
      {
         MessageBox("Your MagicNumber input needs to be at least 5 digits long, Your MagicNumber is " + mn + NL 
                    + "Please reload the robot with the MagicNumber input containing at least 5 digits - the more the better.");
         Comment("                This robot can do nothing. Please reload it");
         DisabledMessage = "You need to make the MagicNumber input at 5 digits long - more is better";
         RobotDisabled = true;
         return;
      }//if (StringLen(mn) < 5)
      
      //Default trade comment needs changing
      if (TradeComment == "ScRT")
      {
         MessageBox("You cannot run this robot until changed the TradeComment input from the default of ScRT." + NL 
                    + "Please reload the robot with a new TradeComment input.");
         Comment("                This robot can do nothing. Please reload it");
         DisabledMessage = "You need to change the TradeComment input";
         RobotDisabled = true;
         return;
      }//if (MagicNumber == 876987)            
   }//if (!IsDemo)
   
   ObjectsDeleteAll(0, OBJ_LABEL);
    
   //Amend inputs to cater for different broker digits
   int dig = MarketInfo(Symbol(), MODE_DIGITS);
   if (dig == 2 || dig == 4)
   {   
      PendingTradesPipsDistance/= 10;
      BEP/= 10;
   }//if (dig = 3)
   
   //Extract the pairs traded by the user
   // Cleanup first
   InputString=PairsToTrade;
   CleanUpInputString();
   
   // Extract the number of paraaters passed by the user
   CalculatePairsPassed();
   
   string AddChar = StringSubstr(Symbol(),6,4);
   
   // Resize the arrays appropriately
   string NewArray = ArrayResize(TradePair, NoOfPairs);
   
   int Index = 0;//For searching InputString
   int LastIndex = 0;//Points the the most recent Index
   for (int cc = 0; cc < NoOfPairs; cc ++)
   {
      Index = StringFind(InputString, ",",LastIndex);
      if (Index > -1)
      {
         TradePair[cc] = StringSubstr(InputString, LastIndex,Index-LastIndex);
         TradePair[cc] = StringTrimLeft(TradePair[cc]);
         TradePair[cc] = StringTrimRight(TradePair[cc]);
         TradePair[cc] = StringConcatenate(TradePair[cc], AddChar);
         
         LastIndex = Index+1;         
      }//if (Index > -1)            
   }//for (int cc; cc<NoOfPairs; cc ++)

    int Step = MarketInfo(Symbol(),MODE_LOTSTEP);
    
    if(Step == 0.01) Decimals = 2;
    if(Step == 0.10) Decimals = 1;
    if(Step == 1.00) Decimals = 0;
    
    Comment("\nWaiting for tick update...");
    
   Gap="";
   if (DisplayGapSize >0)
   {
      for (cc=0; cc< DisplayGapSize; cc++)
      {
         Gap = StringConcatenate(Gap, " ");
      }   
   }

   //Set up ATR call variables
   //Retrace
   if (UseM15ATRrt) RetraceAtrTf = PERIOD_M15;
   if (UseH1ATRrt) RetraceAtrTf = PERIOD_H1;
   if (UseH4ATRrt) RetraceAtrTf = PERIOD_H4;
   if (UseD1ATRrt) RetraceAtrTf = PERIOD_D1;
   
   //TP
   if (UseM15ATRtp) TpAtrTf = PERIOD_M15;
   if (UseH1ATRtp) TpAtrTf = PERIOD_H1;
   if (UseH4ATRtp) TpAtrTf = PERIOD_H4;
   if (UseD1ATRtp) TpAtrTf = PERIOD_D1;
   //SL
   if (UseM15ATRsl) SlAtrTf = PERIOD_M15;
   if (UseH1ATRsl) SlAtrTf = PERIOD_H1;
   if (UseH4ATRsl) SlAtrTf = PERIOD_H4;
   if (UseD1ATRsl) SlAtrTf = PERIOD_D1;
   
   DisplayUserFeedback();

   return(0);
    
  }
  
//+------------------------------------------------------------------+
//| expert Deinitialization function                                 |
//+------------------------------------------------------------------+

int deinit()
  {

    Comment("");
    ObjectsDeleteAll(0, OBJ_LABEL);
    return(0);

  }

void Printtxt(string text, string str,int size, string font, color vcolor, double vertical, double horizontal) 
{
   //if (ObjectFind(str) != 0)
   if (ObjectFind(str) == -1)
   {
      ObjectCreate(str, OBJ_LABEL, 0, 0, 0);      
   }
   ObjectSetText(str, text, size, font, vcolor);
   ObjectSet(str, OBJPROP_XDISTANCE, 0 + horizontal);
   ObjectSet(str, OBJPROP_YDISTANCE, 0 + 14.0 * vertical);
   
}//End void Printtxt(string text, string str,int size, string font, color vcolor = -1, double vertical = -1.0, int horizontal = 0) {

  
//+------------------------------------------------------------------+
//| expert GetPosition function                                      |
//+------------------------------------------------------------------+

void GetPosition()
{

   NoOfTrades = 0;
   if (OrdersTotal() == 0 ) return;
   
   for(int cc = OrdersTotal() - 1; cc >= 0; cc--)
   {
       if(!OrderSelect(cc, SELECT_BY_POS, MODE_TRADES) ) continue;
         
       if(OrderMagicNumber() == MagicNumber)
       {
           NoOfTrades++;
       }//if(OrderSymbol() == symbol && OrderMagicNumber() == MagicNumber)
         
   }//for(int cc = 0; cc <= OrdersTotal(); cc++)
 
 
}//void GetPosition(string symbol)


//+------------------------------------------------------------------+
//| expert SendOrder function                                        |
//+------------------------------------------------------------------+  

  void SendOrder(string symbol, int dir, double lots) 
  {
    
    double price;
    double point;
    double sl;
    double tp;

    int ticket = -1;
    int spread = 10;
    int digit  = 0;
        
    if(MarketInfo(symbol,MODE_DIGITS) == 3 || MarketInfo(symbol,MODE_DIGITS) == 5)
      {
        spread *= 10;
      }
    
   //Trade expiry time
   datetime OrderExpiryTime = TimeCurrent();
   OrderExpiryTime += PendingTradesExpireMinutes * 60;
   
    if(dir == OP_BUY && MarketInfo(symbol,MODE_SPREAD) <= spread)
      {
        while(ticket < 0)
          {
            RefreshRates();
            price  = MarketInfo(symbol,MODE_ASK);
            point  = MarketInfo(symbol,MODE_POINT);
            digit  = MarketInfo(symbol,MODE_DIGITS);
            double AtrVal = Get_ATR(symbol, SlAtrTf, SlAtrMultiplier);
            sl     = NormalizeDouble(price-AtrVal,digit);
            AtrVal = Get_ATR(symbol, TpAtrTf, TpAtrMultiplier);
            tp     = NormalizeDouble(price+AtrVal,digit);
            //ticket = OrderSend(symbol,dir,lots,price,3,sl,tp,TradeComment,MagicNumber,0,CLR_NONE);
            if (!CriminalIsECN) ticket = OrderSend(symbol,OP_BUY,lots,price,3,sl,tp,TradeComment,MagicNumber,0,CLR_NONE);
            if (CriminalIsECN) ticket = OrderSend(symbol,OP_BUY,lots,price,3,0,0,TradeComment,MagicNumber,0,CLR_NONE);
            
            Sleep(1000);
          }
          if (CriminalIsECN)
            {
               OrderSelect(ticket, SELECT_BY_TICKET);
               bool result = OrderModify(ticket, OrderOpenPrice(),	sl, tp, OrderExpiration(), CLR_NONE);
			      if (!result)
			      {
			          int err=GetLastError();
                   Alert(Symbol(), " Buy TP order modify failed with error(",err,"): ",ErrorDescription(err));
			      }//if (!result)
            }
      }//if(dir == OP_BUY && MarketInfo(symbol,MODE_SPREAD) <= spread)
      
   if(dir == OP_BUYSTOP)
      {
        
         RefreshRates();
         point  = MarketInfo(symbol,MODE_POINT);
         digit  = MarketInfo(symbol,MODE_DIGITS);
         price  = NormalizeDouble(MarketInfo(symbol,MODE_ASK) + (PendingTradesPipsDistance * point), digit);
         AtrVal = Get_ATR(symbol, SlAtrTf, SlAtrMultiplier);
         sl     = NormalizeDouble(price-AtrVal,digit);
         AtrVal = Get_ATR(symbol, TpAtrTf, TpAtrMultiplier);
         tp     = NormalizeDouble(price+AtrVal,digit);
         //ticket = OrderSend(symbol,dir,lots,price,3,sl,tp,TradeComment,MagicNumber,0,CLR_NONE);
         if (!CriminalIsECN) ticket = OrderSend(symbol,OP_BUYSTOP,lots,price,3,sl,tp,TradeComment,MagicNumber,OrderExpiryTime,CLR_NONE);
         if (CriminalIsECN) ticket = OrderSend(symbol,OP_BUYSTOP,lots,price,3,0,0,TradeComment,MagicNumber,OrderExpiryTime,CLR_NONE);
         
         Sleep(1000);
          
          if (CriminalIsECN && ticket > -1)
            {
               OrderSelect(ticket, SELECT_BY_TICKET);
               result = OrderModify(ticket, OrderOpenPrice(),	sl, tp, OrderExpiration(), CLR_NONE);
			      if (!result)
			      {
			          err=GetLastError();
                   Alert(Symbol(), " Buy TP order modify failed with error(",err,"): ",ErrorDescription(err));
			      }//if (!result)
            }
      }//f(dir == OP_BUYSTOP)
      
    if(dir == OP_SELL && MarketInfo(symbol,MODE_SPREAD) <= spread)
      {
        while(ticket < 0)
          {
            RefreshRates();
            price  = MarketInfo(symbol,MODE_BID);
            point  = MarketInfo(symbol,MODE_POINT);
            digit  = MarketInfo(symbol,MODE_DIGITS);
            AtrVal = Get_ATR(symbol, SlAtrTf, SlAtrMultiplier);
            sl     = NormalizeDouble(price+AtrVal,digit);
            AtrVal = Get_ATR(symbol, TpAtrTf, TpAtrMultiplier);
            tp     = NormalizeDouble(price-AtrVal,digit);
            //ticket = OrderSend(symbol,dir,lots,price,3,sl,tp,TradeComment,MagicNumber,0,CLR_NONE);
            if (!CriminalIsECN) ticket = OrderSend(symbol,OP_SELL,lots,price,3,sl,tp,TradeComment,MagicNumber,0,CLR_NONE);
            if (CriminalIsECN) ticket = OrderSend(symbol,OP_SELL,lots,price,3,0,0,TradeComment,MagicNumber,0,CLR_NONE);            
            Sleep(1000);
          }
          if (CriminalIsECN)
            {
               OrderSelect(ticket, SELECT_BY_TICKET);
               result = OrderModify(ticket, OrderOpenPrice(),	sl, tp, OrderExpiration(), CLR_NONE);
			      if (!result)
			      {
			          err=GetLastError();
                   Alert(Symbol(), " Sell TP order modify failed with error(",err,"): ",ErrorDescription(err));
			      }//if (!result)
            }//if (CriminalIsECN)
      
      if (ticket > -1) NoOfTrades++;//Ensure trades are sent only up to MaxTradesAllowed
  }//if(dir == OP_SELL && MarketInfo(symbol,MODE_SPREAD) <= spread)

    if(dir == OP_SELLSTOP)
      {
        
         RefreshRates();
         point  = MarketInfo(symbol,MODE_POINT);
         digit  = MarketInfo(symbol,MODE_DIGITS);
         price  = NormalizeDouble(MarketInfo(symbol,MODE_BID) - (PendingTradesPipsDistance * point), digit);
         AtrVal = Get_ATR(symbol, SlAtrTf, SlAtrMultiplier);
         sl     = NormalizeDouble(price+AtrVal,digit);
         AtrVal = Get_ATR(symbol, TpAtrTf, TpAtrMultiplier);
         tp     = NormalizeDouble(price-AtrVal,digit);
         //ticket = OrderSend(symbol,dir,lots,price,3,sl,tp,TradeComment,MagicNumber,0,CLR_NONE);
         if (!CriminalIsECN) ticket = OrderSend(symbol,OP_SELLSTOP,lots,price,3,sl,tp,TradeComment,MagicNumber,OrderExpiryTime,CLR_NONE);
         if (CriminalIsECN) ticket = OrderSend(symbol,OP_SELLSTOP,lots,price,3,0,0,TradeComment,MagicNumber,OrderExpiryTime,CLR_NONE);            
         Sleep(1000);
          
          if (CriminalIsECN && ticket > -1)
            {
               OrderSelect(ticket, SELECT_BY_TICKET);
               result = OrderModify(ticket, OrderOpenPrice(),	sl, tp, OrderExpiration(), CLR_NONE);
			      if (!result)
			      {
			          err=GetLastError();
                   Alert(Symbol(), " Sell TP order modify failed with error(",err,"): ",ErrorDescription(err));
			      }//if (!result)
            }
      }
  
      if (ticket > -1) NoOfTrades++;//Ensure trades are sent only up to MaxTradesAllowed
  }//if(dir == OP_SELLSTOP)


//+------------------------------------------------------------------+
//| expert Trend function                                            |
//+------------------------------------------------------------------+  

void Get_Trend(string symbol)
  {
  
    Trend = flat;
    
    EMA_020_M15 = iMA(symbol,M15,020,0,MODE_EMA,PRICE_CLOSE,0);
    double EMA_020_H01 = iMA(symbol,H01,020,0,MODE_EMA,PRICE_CLOSE,0);
    double EMA_020_H04 = iMA(symbol,H04,020,0,MODE_EMA,PRICE_CLOSE,0);
    double EMA_020_D01 = iMA(symbol,D01,020,0,MODE_EMA,PRICE_CLOSE,0);
    
    double EMA_200_M15 = iMA(symbol,M15,200,0,MODE_EMA,PRICE_CLOSE,0);
    double EMA_200_H01 = iMA(symbol,H01,200,0,MODE_EMA,PRICE_CLOSE,0);
    double EMA_200_H04 = iMA(symbol,H04,200,0,MODE_EMA,PRICE_CLOSE,0);
    double EMA_200_D01 = iMA(symbol,D01,200,0,MODE_EMA,PRICE_CLOSE,0);
    
    if(EMA_020_M15 < EMA_200_M15 && EMA_020_H01 < EMA_200_H01 &&
       EMA_020_H04 < EMA_200_H04 && EMA_020_D01 < EMA_200_D01)
      {
        Trend = down;
      }

    if(EMA_020_M15 > EMA_200_M15 && EMA_020_H01 > EMA_200_H01 &&
       EMA_020_H04 > EMA_200_H04 && EMA_020_D01 > EMA_200_D01)
      {
        Trend = up;
      }
       
    return(Trend);
  
  }

void CleanUpInputString()
{
   // Does any tidying up of the user inputs
   
   //Remove unwanted spaces
   InputString = StringTrimLeft(InputString);
   InputString = StringTrimRight(InputString);

   //Add final comma if ommitted by user
   if (StringSubstr(InputString, StringLen(InputString)-1) != ",") 
      InputString = StringConcatenate(InputString,",");
      
   
}//void CleanUpInputString

void CalculatePairsPassed()
{
   // Calculates the numbers of paramaters passed in LongMagicNumber and TradeComment.
   
   int Index = 0;//For searching NoTradePairs
   int LastIndex;//Points the the most recent Index
   NoOfPairs = 0;
   
   while(Index > -1)
      {
         Index = StringFind(InputString, ",",LastIndex);
         if (Index > -1)
         {
            NoOfPairs ++;
            LastIndex = Index+1;            
         }//if (Index > -1)
      }//while(int cc > -1)
   
   
   
}//End void CalculatePairsPassed()

double Get_ATR(string symbol, int tf, int multiplier)
{
   
   return(iATR(symbol, tf, AtrPeriod, 0) * multiplier);
   
}//End double Get_ATR(string symbol, int tf, int multiplier)



bool DoesTradeExist(string symbol)
{
   TicketNo=0;
   if (OrdersTotal() == 0) return(false);
   
   for (int cc = OrdersTotal() - 1; cc >=0; cc--)
   {
      if (!OrderSelect(cc, SELECT_BY_POS) ) continue;
      if (OrderSymbol() == symbol && OrderMagicNumber() ==  MagicNumber)
      {
         TicketNo = OrderTicket();
         return(true);
      }//if (OrderSymbol() == symbol && OrderMagicNumber() ==  MagicNumber)      
   }//for (int cc = OrdersTotal() - 1; cc >=0)
   
   //Got this far, so no trade open
   return(false);

}//End bool DoesTradeExist(string symbol)

void ManageTrades()
{
   //Manage moving stops to be and closing half the trade.
   //Close the trade if the trend that allowed it has changed.

   for (int cc = OrdersTotal() - 1; cc >= 0; cc--)
   {
      while (!IsTradeAllowed() )
      {
         Comment("Trying to manage trades, but trading not allowed by the criminal");
      }//while (!IsTradeAllowed() )
      
                  
      if (!OrderSelect(cc, SELECT_BY_POS) ) continue;
      string symbol = OrderSymbol();
      if (OrderMagicNumber() ==  MagicNumber && IsTradeAllowed() && OrderLots() > Lots / 2)
      {
         //Look at trade closure
         Get_Trend(symbol);
         if (Trend == flat)
         {
            OrderClose(OrderTicket(), OrderLots(), OrderClosePrice(), 100, CLR_NONE);
            return;//Cycle around again at the next tick - easier to code
         }//if (Trend = flat)         
         double AtrVal = (Get_ATR(OrderSymbol(), TpAtrTf, TpAtrMultiplier) / 2);
         if (OrderProfit() > 0)
         {
            bool result = false;
            double CloseLots = OrderLots() / 2;
            
            if (OrderType() == OP_BUY)
            {
               double ask = MarketInfo(symbol, MODE_ASK);
               double digits =  MarketInfo(symbol, MODE_DIGITS);
               if (ask >= NormalizeDouble(OrderOpenPrice() + AtrVal, digits) )
               {
                  result = OrderClose(OrderTicket(), CloseLots, OrderClosePrice(), 500, CLR_NONE);
                  if (!result)
                  {
                       int err=GetLastError();
                       Alert(Symbol(), " Trend retracement robot ", OrderType()," part-close failed with error(",err,"): ",ErrorDescription(err));
                       return;
                  }//if (!result)
                  //Get new ticket number
                  Sleep(100);
                  DoesTradeExist(symbol);
                  OrderSelect(TicketNo, SELECT_BY_TICKET);
                  
               }//if (ask >= NormalizeDouble(OrderOpenPrice() + AtrVal, digits) )
               
            }//if (OrderType() == OP_BUY)
            
            if (OrderType() == OP_SELL)
            {
               double bid = MarketInfo(symbol, MODE_ASK);
               digits =  MarketInfo(symbol, MODE_DIGITS);
               if (bid <= NormalizeDouble(OrderOpenPrice() - AtrVal, digits) )
               {   
                  result = OrderClose(OrderTicket(), CloseLots, OrderClosePrice(), 500, CLR_NONE);
                  if (!result)
                  {
                       err=GetLastError();
                       Alert(OrderSymbol(), " Trend retracement robot ", OrderType()," part-close failed with error(",err,"): ",ErrorDescription(err));
                       return;
                  }//if (!result)
                  //Get new ticket number
                  Sleep(100);
                  DoesTradeExist(symbol);
                  OrderSelect(TicketNo, SELECT_BY_TICKET);
                  
               }//if (bid <= NormalizeDouble(OrderOpenPrice() - AtrVal, digits) )
            }//if (OrderType() == OP_SELL)
            
            //Move stops to breakeven. Also mops up failed stop move attempts.
            double point = MarketInfo(OrderSymbol(), MODE_POINT);
            if (OrderType() == OP_BUY) 
            {
               if (OrderStopLoss() < OrderOpenPrice() && OrderLots() < Lots)
               {
                  double SL = NormalizeDouble(OrderOpenPrice() + (BEP * point), 2);
                  result = OrderModify(OrderTicket(), OrderOpenPrice(), SL, OrderTakeProfit(), 0, CLR_NONE);
                  if (!result)
                   {
                       err=GetLastError();
                       Alert(OrderSymbol(), " Trend retracement robot ", OrderType(), " Stop loss move failed with error(",err,"): ",ErrorDescription(err));
                       return;
                   }//if (!result)     
               }//if (OrderStopLoss() < OrderOpenPrice() && OrderLots() < Lots)
            }//if (OrderType() == OP_BUY) 
            
            if (OrderType() == OP_SELL)
            {
               if (OrderStopLoss() > OrderOpenPrice() && OrderLots() < Lots)
               {
                  SL = NormalizeDouble(OrderOpenPrice() - (BEP * point), 2);
                  result = OrderModify(OrderTicket(), OrderOpenPrice(), SL, OrderTakeProfit(), 0, CLR_NONE);
                  if (!result)
                   {
                       err=GetLastError();
                       Alert(OrderSymbol(), " Trend retracement robot ", OrderType(), " Stop loss move failed with error(",err,"): ",ErrorDescription(err));
                       return;
                   }//if (!result)     
               }//if (OrderStopLoss() < OrderOpenPrice() && OrderLots() < Lots)
               
            }//if (OrderType() == OP_SELL)
            
            
                     
         }//if (OrderProfit() > 0)
         
      }//if (OrderSymbol() == symbol && OrderMagicNumber() ==  MagicNumber)      
   }//for (int cc = OrdersTotal() - 1; cc >=0)
   
}//void ManageTrades()

double GetTriggerPrice(int type, string symbol, double AtrVal)
{
   //Returns the retrace price at which the robot will place a pending trade
   
   int digits = MarketInfo(symbol, MODE_DIGITS);
   
   if (type == OP_BUY)
   {
      return(NormalizeDouble(EMA_020_M15 - AtrVal, digits) );   
   }//if (type == long)
   
   if (type == OP_SELL)
   {
      return(NormalizeDouble(EMA_020_M15 + AtrVal, digits) );   
   }//if (type == long)
   

}//End double GetTriggerPrice(int type, string symbol, double AtrVal)

void GetSwing(string symbol)
{
   //Detects a swing high or low
   
   Swing = none;
   SwingHigh = 0;
   SwingLow = 0;

   //Swing high
   double PrevHigh = iHigh(symbol, 0, 3);
   if (iHigh(symbol, 0, 1) < PrevHigh && iHigh(symbol, 0, 2) < PrevHigh && iHigh(symbol, 0, 4) < PrevHigh && iHigh(symbol, 0, 5) < PrevHigh)
   {
      Swing = high;
      SwingHigh = PrevHigh;
      return;
   }

   //Swing low
   double PrevLow = iLow(symbol, 0, 3);
   if (iLow(symbol, 0, 1) > PrevLow && iLow(symbol, 0, 2) > PrevLow && iLow(symbol, 0, 4) > PrevLow && iLow(symbol, 0, 5) > PrevLow)
   {
      Swing = low;
      SwingLow = PrevLow;
   }

}//End void GetSwing(string symbol)

//+------------------------------------------------------------------+
//| expert Start function                                            |
//+------------------------------------------------------------------+

int start()
{
    
   if (RobotDisabled )
   {
      Comment("The robot has been suspended. Reason: ", DisabledMessage);
      return;
   }//if (RobotDisabled )

    GetPosition();
    if(NoOfTrades > 0) ManageTrades();
    
    //Check Friday close
   if (FridayClose)
   {
      ClosedForFriday = false;
      if (TimeHour(TimeLocal() ) >= StopTradinhHour && TimeDayOfWeek(TimeLocal() ) == 5)
      {
         ClosedForFriday = true;
         return;
      }//if (TimeHour(TimeLocal()) >= StopTradinhHour && DayOfWeek() == 5)
   }//if (FridayClose)
   
   //Check Saturday close for Aitipodeans
   if (SaturdayClose)
   {
      ClosedForSaturday = false;
      if (TimeHour(TimeLocal() ) >= StopTradinhHour && TimeDayOfWeek(TimeLocal() ) == 6)
      {
         ClosedForSaturday = true;
         return;
      }//if (TimeHour(TimeLocal()) >= StopTradinhHour && DayOfWeek() == 5)
   }//if (Saturday)
   
    if (TradingSuspended) return;
    
    for(int cc = 0; cc < ArraySize(TradePair); cc++)
    {

       if(NoOfTrades >= MaxTradesAllowed) break;
       
       string symbol = TradePair[cc];//Simplifies typing
       
       if(iClose(symbol,0,0) > 0)
       {      
         
            bool TradeExists = DoesTradeExist(symbol);
            
            if (!TradeExists)
            {
               Get_Trend(symbol);
              
               double bid = MarketInfo(symbol, MODE_BID);
               double ask = MarketInfo(symbol, MODE_ASK);
                             
               //Fixed retrace = EMA_020_M15 minus 20% of the D1 ATR.
               //scoobs suggested 25%; 20% is an arbitrary figure that allows the market to move above/below the ema
               if(UseAtrRetrace)
               {
                  //Flexible retrace based on user's chosen preference
                  double AtrVal = Get_ATR(symbol, RetraceAtrTf, RetraceAtrMultiplier);
                  
                  //Fixed retrace
                  //AtrVal = Get_ATR(symbol, PERIOD_D1, 1) / 4;
               
                     
                  if(Trend == up)
                  {
                                              
                      if (IsTradeAllowed())               {   
                     
                         if(ask <= EMA_020_M15 - AtrVal)//Pending buy stop
                         {                    
                            SendOrder(symbol,OP_BUYSTOP, Lots);
                            NoOfTrades++;
                         }//if(ask <= EMA_020_M15 - AtrVal)
                     
                     
                      }//if (IsTradeAllowed)
                     
                  }//if(Trend == up)

                  if(Trend == down)                        
                  {
                      if (IsTradeAllowed())
                      {   
                     
                         if(bid >= EMA_020_M15 + AtrVal)//Pending sell stop
                         {
                           SendOrder(symbol,OP_SELLSTOP,Lots);
                           NoOfTrades++;
                         }//if(bid >= EMA_020_M15 + AtrVal)
                      }//if (IsTradeAllowed)   
                 }//if(Trend == down)                        
               }//if(UseAtrRetrace)

               //Swing hi-lo retrace
               if(UseSwingRetrace)
               {
                  
                  GetSwing(symbol);
                     
                  if(Trend == up)
                  {
                                              
                      if (IsTradeAllowed())               {   
                     
                         if(Swing == low && ask > iOpen(symbol, SwingTimeFrame, 0) )
                         {                    
                            SendOrder(symbol,OP_BUYSTOP, Lots);
                            NoOfTrades++;
                         }//if(ask <= EMA_020_M15 - AtrVal)
                     
                     
                      }//if (IsTradeAllowed)
                     
                  }//if(Trend == up)

                  if(Trend == down)                        
                  {

                      if (IsTradeAllowed())
                      {   
                     
                         if(Swing == high && bid < iOpen(symbol, SwingTimeFrame, 0) )
                         {
                           SendOrder(symbol,OP_SELLSTOP,Lots);
                           NoOfTrades++;
                         }//if(bid >= EMA_020_M15 + AtrVal)
                      }//if (IsTradeAllowed)   
                 }//if(Trend == down)                        
               }//if(UseAtrRetrace)



            }//if (!TradeExists)
            
         }//if(iClose(symbol,0,0) > 0)
      
      }//for(int cc = 0; cc < ArraySize(TradePair); cc++)
      
    return(0);

}//End start()


